    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ---------------------------
    028     * CategoryLabelWidthType.java
    029     * ---------------------------
    030     * (C) Copyright 2004, 2005, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * $Id: CategoryLabelWidthType.java,v 1.4.2.1 2005/10/25 20:37:34 mungady Exp $
    036     *
    037     * Changes:
    038     * --------
    039     * 24-Mar-2004 : Version 1 (DG);
    040     *
    041     */
    042
    043    package org.jfree.chart.axis;
    044
    045    import java.io.ObjectStreamException;
    046    import java.io.Serializable;
    047
    048    /**
    049     * Represents the width types for a category label.
    050     */
    051    public final class CategoryLabelWidthType implements Serializable {
    052
    053        /** For serialization. */
    054        private static final long serialVersionUID = -6976024792582949656L;
    055
    056        /** Percentage of category. */
    057        public static final CategoryLabelWidthType
    058            CATEGORY = new CategoryLabelWidthType(
    059                "CategoryLabelWidthType.CATEGORY"
    060            );
    061
    062        /** Percentage of range. */
    063        public static final CategoryLabelWidthType
    064            RANGE = new CategoryLabelWidthType("CategoryLabelWidthType.RANGE");
    065
    066        /** The name. */
    067        private String name;
    068
    069        /**
    070         * Private constructor.
    071         *
    072         * @param name  the name (<code>null</code> not permitted).
    073         */
    074        private CategoryLabelWidthType(String name) {
    075            if (name == null) {
    076                throw new IllegalArgumentException("Null 'name' argument.");
    077            }
    078            this.name = name;
    079        }
    080
    081        /**
    082         * Returns a string representing the object.
    083         *
    084         * @return The string (never </code>null</code>).
    085         */
    086        public String toString() {
    087            return this.name;
    088        }
    089
    090        /**
    091         * Returns <code>true</code> if this object is equal to the specified
    092         * object, and <code>false</code> otherwise.
    093         *
    094         * @param obj  the other object.
    095         *
    096         * @return A boolean.
    097         */
    098        public boolean equals(Object obj) {
    099
    100            if (this == obj) {
    101                return true;
    102            }
    103            if (!(obj instanceof CategoryLabelWidthType)) {
    104                return false;
    105            }
    106            CategoryLabelWidthType t = (CategoryLabelWidthType) obj;
    107            if (!this.name.equals(t.toString())) {
    108                return false;
    109            }
    110            return true;
    111
    112        }
    113
    114        /**
    115         * Ensures that serialization returns the unique instances.
    116         *
    117         * @return The object.
    118         *
    119         * @throws ObjectStreamException if there is a problem.
    120         */
    121        private Object readResolve() throws ObjectStreamException {
    122            if (this.equals(CategoryLabelWidthType.CATEGORY)) {
    123                return CategoryLabelWidthType.CATEGORY;
    124            }
    125            else if (this.equals(CategoryLabelWidthType.RANGE)) {
    126                return CategoryLabelWidthType.RANGE;
    127            }
    128            return null;
    129        }
    130
    131    }